import java.awt.Panel;
import java.awt.Frame;
import java.awt.Button;
import java.awt.GridLayout;
import java.awt.GraphicsEnvironment;
import java.awt.Dimension;
import java.awt.event.*;
import ij.gui.*;
import ij.ImagePlus;

public class MultiRoiToolsPanel implements ActionListener {
	private Button btnClear, btnCopyFromLast, btnCopyToLast, btnCopyFromNext, btnCopyToNext, btnDumpFrame, btnDumpAll, btnDeleteCurrent;
	MultiRoiStackCanvas ic;
	ImagePlus imp;
	MultiRoiToolsPanel(ImagePlus imp, MultiRoiStackCanvas ic) {
		this.ic = ic;
		this.imp = imp;
		Frame panel = new Frame("MultiRoi Tools");
		GridLayout layout = new GridLayout(7,1);
		panel.setLayout(layout);
		btnClear = new Button("Clear ROIs in frame");
		btnClear.addActionListener(this);
		panel.add(btnClear);

		btnCopyFromLast = new Button("Copy ROIs from previous frame");
		btnCopyFromLast.addActionListener(this);
		panel.add(btnCopyFromLast);

		btnCopyToLast = new Button("Copy ROIs to previous frame");
		btnCopyToLast.addActionListener(this);
		panel.add(btnCopyToLast);

		btnCopyToNext = new Button("Copy ROIs to next frame");
		btnCopyToNext.addActionListener(this);
		panel.add(btnCopyToNext);

		btnCopyFromNext = new Button("Copy ROIs from next frame");
		btnCopyFromNext.addActionListener(this);
		panel.add(btnCopyFromNext);

		btnDumpFrame = new Button("Dump ROIs in this frame to log");
		btnDumpFrame.addActionListener(this);
		panel.add(btnDumpFrame);

		btnDumpAll = new Button("Dump all ROIs to log");
		btnDumpAll.addActionListener(this);
		panel.add(btnDumpAll);
		
		btnDeleteCurrent = new Button("Delete current ROI");
		btnDeleteCurrent.addActionListener(this);
		panel.add(btnDeleteCurrent);
		//panel.setSize(panel.getPreferredSize());
		panel.setSize(new Dimension(200,200));
		panel.setVisible(true);
	}
	
	public void actionPerformed(ActionEvent e) {
		Object b = e.getSource();
		if (b == btnClear) {
			ic.clear(imp.getCurrentSlice());
		} else if (b == btnCopyFromLast) {
			ic.copyRois(imp.getCurrentSlice()-1,imp.getCurrentSlice());
		} else if (b == btnCopyToLast) {
			ic.copyRois(imp.getCurrentSlice(), imp.getCurrentSlice()-1);
		} else if (b == btnCopyFromNext) {
			ic.copyRois(imp.getCurrentSlice()+1, imp.getCurrentSlice());
		} else if (b == btnCopyToNext) {
			ic.copyRois(imp.getCurrentSlice(), imp.getCurrentSlice()+1);
		} else if (b == btnDumpFrame) {
			ic.dumpFrame(imp.getCurrentSlice());
		} else if (b == btnDumpAll) {
			ic.dumpStack();
		} else if (b == btnDeleteCurrent) {
			imp.setRoi((Roi)null);
		}
	}
	
}
